import "./stepper.css";
import { defineComponent as I, resolveComponent as B, openBlock as t, createElementBlock as s, mergeProps as k, createElementVNode as i, Fragment as m, renderList as f, normalizeClass as h, createBlock as u, resolveDynamicComponent as b, toDisplayString as n, createCommentVNode as a, renderSlot as g, normalizeProps as N, withCtx as c, createTextVNode as v, createVNode as $, guardReactiveProps as T } from "vue";
import D from "../button/button.js";
import { c as S, p as P, x as E } from "../../icons-fca12ed8.js";
import { _ as F } from "../../_plugin-vue_export-helper-dad06003.js";
import "../tooltip/tooltip.js";
const w = I({
  emits: {
    "update:modelValue": (e) => !0,
    change: (e) => !0,
    finish: () => !0
  },
  props: {
    alternateTitle: {
      required: !1,
      type: Boolean
    },
    hideFooter: {
      required: !1,
      type: Boolean
    },
    interceptNav: {
      required: !1,
      type: Function
    },
    items: {
      required: !0,
      type: Object
    },
    mobile: {
      required: !1,
      type: Boolean
    },
    modelValue: {
      required: !0,
      type: Number
    },
    nonLinear: {
      required: !1,
      type: Boolean
    },
    type: {
      default: "horizontal",
      type: String
    }
  },
  name: "sb-stepper",
  components: {
    "sb-button": D
  },
  data() {
    return {
      isButtonDisabled: !1,
      localCurrent: 1,
      localItems: []
    };
  },
  computed: {
    getNextColor() {
      return this.localItems[this.localCurrent - 1].nextColor || "secondary";
    },
    getNextText() {
      return this.localItems[this.localCurrent - 1].nextText || "next";
    },
    getPrevColor() {
      return this.localItems[this.localCurrent - 1].prevColor || "secondary";
    },
    getPrevText() {
      return this.localItems[this.localCurrent - 1].prevText || "prev";
    },
    getSkipText() {
      return this.localItems[this.localCurrent - 1].optionalText || "skip";
    },
    iconCheck() {
      return S();
    },
    iconPen() {
      return P();
    },
    iconXMark() {
      return E();
    },
    isNextDisabled() {
      return this.isError(
        this.localItems[this.localCurrent - 1].rules
      ) || this.isButtonDisabled;
    }
  },
  methods: {
    doNavigate(e) {
      this.localCurrent + e <= this.items.length ? (this.$emit("update:modelValue", this.localCurrent + e), this.$emit("change", this.localCurrent + e)) : this.localCurrent === this.items.length && this.$emit("finish");
    },
    async handleClickHead(e) {
      return await this.handleNav(e + 1 - this.localCurrent);
    },
    async handleNav(e, o = !1) {
      if (o)
        this.localItems[this.localCurrent - 1].isSkip = !0, this.doNavigate(e);
      else {
        const d = this.localCurrent + e;
        if (this.localItems[d - 1] && this.localItems[d - 1].optional && this.localItems[d - 1].isSkip && (this.localItems[d - 1].isSkip = !1), this.interceptNav) {
          this.isButtonDisabled = !0;
          const y = await this.interceptNav(
            this.localCurrent + e
          );
          this.isButtonDisabled = !1, y && this.doNavigate(e);
        } else
          this.doNavigate(e);
      }
    },
    isError(e) {
      return e ? e.some(
        (d) => !d()
      ) : !1;
    },
    isFilled(e) {
      return this.localCurrent > e + 1;
    }
  },
  watch: {
    items: {
      deep: !0,
      handler(e) {
        this.localItems = [...e];
      },
      immediate: !0
    },
    modelValue: {
      handler(e) {
        this.localCurrent = e;
      },
      immediate: !0
    }
  }
});
const V = { class: "stepper-header" }, q = ["onClick"], z = { class: "header-step-number-wrapper" }, L = { key: 3 }, M = { key: 0 }, H = { class: "stepper-body" }, O = { class: "action-buttons" }, X = { class: "stepper-body" }, j = { class: "action-buttons" };
function R(e, o, d, y, A, G) {
  const p = B("sb-button");
  return t(), s("div", k({
    class: ["stepper-wrapper", [e.type]]
  }, { ...e.$attrs }), [
    i("div", V, [
      (t(!0), s(m, null, f(e.localItems, (l, r) => (t(), s(m, {
        key: `header-step-${r}`
      }, [
        i("div", {
          class: h(["header-step", {
            "non-linear": e.nonLinear,
            active: e.localCurrent >= r + 1 && !l.isSkip,
            alternate: e.alternateTitle,
            error: e.isError(l.rules),
            filled: e.isFilled(r)
          }]),
          onClick: () => e.nonLinear && e.handleClickHead(r)
        }, [
          i("div", z, [
            e.isError(l.rules) ? (t(), u(b(e.iconXMark), { key: 0 })) : e.localCurrent === r + 1 && !l.isSkip ? (t(), u(b(e.iconPen), { key: 1 })) : e.isFilled(r) && !l.isSkip ? (t(), u(b(e.iconCheck), { key: 2 })) : (t(), s("span", L, n(r + 1), 1))
          ]),
          e.mobile ? a("", !0) : (t(), s("div", {
            key: 0,
            class: h([{
              error: e.isError(l.rules)
            }, "header-step-label-wrapper"])
          }, [
            i("div", null, n(l.title), 1),
            l.subtitle ? (t(), s("div", M, n(l.subtitle), 1)) : a("", !0)
          ], 2)),
          e.type === "vertical" ? (t(), s("div", {
            key: 1,
            class: h(["content-wrapper", {
              expanded: e.localCurrent === r + 1
            }])
          }, [
            i("div", H, [
              i("div", {
                class: "stepper-body-content",
                ref_for: !0,
                ref: `body-content-${r + 1}`
              }, [
                e.localCurrent === r + 1 ? g(e.$slots, "step", N(k({ key: 0 }, {
                  ...l,
                  index: r + 1
                })), void 0, !0) : a("", !0)
              ], 512)
            ]),
            e.hideFooter ? a("", !0) : (t(), s("div", {
              key: 0,
              class: h(["stepper-footer", { "only-next": e.localCurrent === 1 }])
            }, [
              r !== 0 ? (t(), u(p, {
                key: 0,
                color: e.getPrevColor,
                disabled: e.isButtonDisabled,
                "no-elevation": "",
                type: "button",
                variant: "outlined",
                onClick: o[0] || (o[0] = (C) => e.handleNav(-1))
              }, {
                default: c(() => [
                  v(n(e.getPrevText), 1)
                ]),
                _: 1
              }, 8, ["color", "disabled"])) : a("", !0),
              i("div", O, [
                e.localItems[e.localCurrent - 1].optional ? (t(), u(p, {
                  key: 0,
                  disabled: e.isButtonDisabled,
                  "no-elevation": "",
                  color: "secondary",
                  type: "button",
                  variant: "outlined",
                  onClick: o[1] || (o[1] = (C) => e.handleNav(1, !0))
                }, {
                  default: c(() => [
                    v(n(e.getSkipText), 1)
                  ]),
                  _: 1
                }, 8, ["disabled"])) : a("", !0),
                $(p, {
                  type: "button",
                  color: e.getNextColor,
                  disabled: e.isNextDisabled,
                  onClick: o[2] || (o[2] = (C) => e.handleNav(1))
                }, {
                  default: c(() => [
                    v(n(e.getNextText), 1)
                  ]),
                  _: 1
                }, 8, ["color", "disabled"])
              ])
            ], 2))
          ], 2)) : a("", !0)
        ], 10, q),
        r !== e.localItems.length - 1 && e.type !== "vertical" ? (t(), s("hr", {
          key: 0,
          class: h(["header-step_divider", {
            active: e.isFilled(r),
            mobile: e.mobile
          }])
        }, null, 2)) : a("", !0)
      ], 64))), 128))
    ]),
    e.type === "horizontal" ? (t(), s(m, { key: 0 }, [
      i("div", X, [
        (t(!0), s(m, null, f(e.localItems, (l, r) => (t(), s(m, {
          key: `body-content-${r}`
        }, [
          e.localCurrent === r + 1 ? (t(), s("div", {
            key: 0,
            ref_for: !0,
            ref: `body-content-${r + 1}`,
            class: "stepper-body-content"
          }, [
            g(e.$slots, "step", N(T({
              ...l,
              index: r + 1
            })), void 0, !0)
          ], 512)) : a("", !0)
        ], 64))), 128))
      ]),
      e.hideFooter ? a("", !0) : (t(), s("div", {
        key: 0,
        class: h(["stepper-footer", { "only-next": e.localCurrent === 1 }])
      }, [
        e.localCurrent !== 1 ? (t(), u(p, {
          key: 0,
          color: e.getPrevColor,
          disabled: e.isButtonDisabled,
          "no-elevation": "",
          type: "button",
          variant: "outlined",
          onClick: o[3] || (o[3] = (l) => e.handleNav(-1))
        }, {
          default: c(() => [
            v(n(e.getPrevText), 1)
          ]),
          _: 1
        }, 8, ["color", "disabled"])) : a("", !0),
        i("div", j, [
          e.localItems[e.localCurrent - 1].optional ? (t(), u(p, {
            key: 0,
            disabled: e.isButtonDisabled,
            "no-elevation": "",
            color: "secondary",
            type: "button",
            variant: "outlined",
            onClick: o[4] || (o[4] = (l) => e.handleNav(1, !0))
          }, {
            default: c(() => [
              v(n(e.getSkipText), 1)
            ]),
            _: 1
          }, 8, ["disabled"])) : a("", !0),
          $(p, {
            type: "button",
            color: e.getNextColor,
            disabled: e.isNextDisabled,
            onClick: o[5] || (o[5] = (l) => e.handleNav(1))
          }, {
            default: c(() => [
              v(n(e.getNextText), 1)
            ]),
            _: 1
          }, 8, ["color", "disabled"])
        ])
      ], 2))
    ], 64)) : a("", !0)
  ], 16);
}
const Y = /* @__PURE__ */ F(w, [["render", R], ["__scopeId", "data-v-b42a5c0d"]]);
export {
  Y as default
};
